const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const user_achievements = sequelize.define(
    'user_achievements',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

progress_value: {
        type: DataTypes.INTEGER,
      
      

      },

is_completed: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

completed_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  user_achievements.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





































//end loop



    db.user_achievements.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.user_achievements.belongsTo(db.achievements, {
      as: 'achievement',
      foreignKey: {
        name: 'achievementId',
      },
      constraints: false,
    });




    db.user_achievements.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.user_achievements.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return user_achievements;
};


